searchData={"items":[{"type":"module","title":"Jellyfish","doc":"Jellyfish is a library designed to streamline the management of appup\nand release files, enabling hot-upgrades for Elixir applications.","ref":"Jellyfish.html"},{"type":"module","title":"Jellyfish.Releases.Appups","doc":"Generate appup files for hot upgrades\n\nCopied and/or modified from https://github.com/bitwalker/distillery/blob/master/lib/distillery/releases/appups.ex","ref":"Jellyfish.Releases.Appups.html"},{"type":"function","title":"Jellyfish.Releases.Appups.locate/3","doc":"Given an application name, and two versions, look for a custom appup which applies.","ref":"Jellyfish.Releases.Appups.html#locate/3"},{"type":"function","title":"Jellyfish.Releases.Appups.make/6","doc":"Generate a .appup for the given application, start version, and upgrade version.","ref":"Jellyfish.Releases.Appups.html#make/6"},{"type":"function","title":"Parameters - Jellyfish.Releases.Appups.make/6","doc":"- application: the application name as an atom\n    - v1: the previous version, such as \"0.0.1\"\n    - v2: the new version, such as \"0.0.2\"\n    - v1_path: the path to the v1 artifacts (rel/ /lib/ -0.0.1)\n    - v2_path: the path to the v2 artifacts (_build/prod/lib/ )","ref":"Jellyfish.Releases.Appups.html#make/6-parameters"},{"type":"type","title":"Jellyfish.Releases.Appups.app/0","doc":"","ref":"Jellyfish.Releases.Appups.html#t:app/0"},{"type":"type","title":"Jellyfish.Releases.Appups.appup/0","doc":"","ref":"Jellyfish.Releases.Appups.html#t:appup/0"},{"type":"type","title":"Jellyfish.Releases.Appups.appup_ver/0","doc":"","ref":"Jellyfish.Releases.Appups.html#t:appup_ver/0"},{"type":"type","title":"Jellyfish.Releases.Appups.change/0","doc":"","ref":"Jellyfish.Releases.Appups.html#t:change/0"},{"type":"type","title":"Jellyfish.Releases.Appups.dep_mods/0","doc":"","ref":"Jellyfish.Releases.Appups.html#t:dep_mods/0"},{"type":"type","title":"Jellyfish.Releases.Appups.downgrade_instructions/0","doc":"","ref":"Jellyfish.Releases.Appups.html#t:downgrade_instructions/0"},{"type":"type","title":"Jellyfish.Releases.Appups.instruction/0","doc":"","ref":"Jellyfish.Releases.Appups.html#t:instruction/0"},{"type":"type","title":"Jellyfish.Releases.Appups.path_str/0","doc":"","ref":"Jellyfish.Releases.Appups.html#t:path_str/0"},{"type":"type","title":"Jellyfish.Releases.Appups.upgrade_instructions/0","doc":"","ref":"Jellyfish.Releases.Appups.html#t:upgrade_instructions/0"},{"type":"type","title":"Jellyfish.Releases.Appups.version_str/0","doc":"","ref":"Jellyfish.Releases.Appups.html#t:version_str/0"},{"type":"module","title":"Jellyfish.Releases.Generate","doc":"This module is responsible for generating, moving and packing the release with appup files.","ref":"Jellyfish.Releases.Generate.html"},{"type":"function","title":"Jellyfish.Releases.Generate.appup_files/1","doc":"","ref":"Jellyfish.Releases.Generate.html#appup_files/1"},{"type":"task","title":"mix compile.copy_appup","doc":"This Mix task copies the appup and Jellyfish metadata files to their respective release directories.\n\nCopied/modified from https://preview.hex.pm/preview/forecastle/0.1.2/show/lib/mix/tasks/compile/appup.ex","ref":"Mix.Tasks.Compile.CopyAppup.html"},{"type":"task","title":"mix compile.gen_appup","doc":"Locate previous versions and triggers the appup files generation for hot upgrades\n\nCopied/modified from https://github.com/bitwalker/distillery/blob/master/lib/distillery/tasks/gen.appup.ex\n\nThe generated appup will be written to `rel/appups/ / _to_ .appup`. You may name\nappups anything you wish in this directory, as long as they have a `.appup` extension. When you\nbuild a release, the appup generator will look for missing appups in this directory structure, and\nscan all `.appup` files for matching versions. If you have multiple appup files which match the current\nrelease, then the first one encountered will take precedence, which more than likely will depend on the\nsort order of the names.","ref":"Mix.Tasks.Compile.GenAppup.html"},{"type":"extras","title":"Jellyfish","doc":"# Jellyfish\n\n> Simplifying Hot-Upgrades for Elixir Applications\n\n[![Hex.pm Version](http://img.shields.io/hexpm/v/jellyfish.svg?style=flat)](https://hex.pm/packages/jellyfish)\n\nJellyfish is a library designed to streamline the management of appup and release files, enabling hot-upgrades for Elixir applications. Born from the integration of concepts and functionalities from three influential repositories:\n\n * [Distillery](https://github.com/bitwalker/distillery)\n * [Forecastle](https://github.com/ausimian/forecastle)\n * [Relx](https://github.com/erlware/relx/blob/main/priv/templates/install_upgrade_escript)","ref":"readme.html"},{"type":"extras","title":"Installation - Jellyfish","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `jellyfish` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:jellyfish, \"~> 0.2.0\"}\n  ]\nend\n```\n\nYou also need to add the following line in the mix project\n```elixir\n  def project do\n    [\n      ...\n      releases: [\n        your_app_name: [\n          steps: [:assemble, &Jellyfish.Releases.Copy.appup_files/1, :tar]\n        ]\n      ],\n      ...\n    ]\n  end\n```\n\nOnce the mix release file is generated, it will contain all the appup file to execute a hot-upgrade or full deployment.\n\n# Appup file\n\nIf for any reason you need to change the order of the modules or add new commands in the appup file, you have 2 options:\n\n 1. Use the __EDIT_APPUP__ environment variable to indicate to Jellifish that you want to edit the file before the release:\n```bash\nEDIT_APPUP=true MIX_ENV=prod mix release\n```\n\n 2. Untar the release, do the changes in the appup files and tar it again.\n\n# Relup file\n\nThe library focuses on generating appup files and includes them in the mix release package. It doesn't create relup files directly. The relup file is typically created during a hot upgrade with the [DeployEx](https://github.com/thiagoesteves/deployex) application.\n\n# Elixir Umbrella applications\n\nThe next sections describe how to set up and use Jellyfish with Elixir umbrella applications for hot code upgrades.","ref":"readme.html#installation"},{"type":"extras","title":"Versioning - Jellyfish","doc":"Elixir umbrella applications contain multiple apps with multiple `mix.exs` files and versions. Jellyfish expects a single version for the entire umbrella application, so it's important to ensure the same version is used across all apps. The recommended approach is to use a `version.txt` file at the root of your umbrella project.\n\nRoot Mix File Setup:\n```Elixir\ndefmodule Myumbrella.MixProject do\n  use Mix.Project\n\n  @version File.read!(\"version.txt\")\n\n  def project do\n    [\n      apps_path: \"apps\",\n      version: @version,\n      start_permanent: Mix.env() == :prod,\n      deps: deps(),\n      releases: [\n        myumbrella: [\n          applications: [\n            app_1: :permanent,\n            app_2: :permanent,\n            app_web: :permanent\n          ],\n          steps: [\n            :assemble,\n            &Jellyfish.Releases.Generate.appup_files/1,\n            :tar\n          ]\n        ]\n      ]\n    ]\n\n      defp deps do\n    [\n      {:jellyfish,\n       github: \"thiagoesteves/jellyfish\", ref: \"9aaec1bd70176cf11f72b42921ecc85412c4ca7b\"}\n    ]\n  end\nend\n```\n\nEach application within the umbrella should reference the same version file:\n\nChild App Mix File Setup\n```Elixir\ndefmodule App1.MixProject do\n  use Mix.Project\n\n  @version File.read!(\"../../version.txt\")\n\n  def project do\n    [\n      app: :app_1,\n      version: @version,\n      # Other configuration...\n    ]\n  end\n  # Rest of the mix file...\nend\n```","ref":"readme.html#versioning"},{"type":"extras","title":"Generating Appup files - Jellyfish","doc":"When building releases for hot code upgrades in umbrella applications, there's a known issue where the first release call after a version change doesn't properly update all the applications within the umbrella. This can result in missing or incorrect appup files. For proper appup file generation, follow these steps:\n\n1. Build the initial release:\n```bash\n# Release the version 0.1.0\nMIX_ENV=prod mix assets.deploy\nMIX_ENV=prod mix release\n```\n\n2. Update the version (e.g., from `0.1.0` to `0.1.1`) in `version.txt`\n3. Build the new release with forced compilation:\n```bash\nMIX_ENV=prod mix assets.deploy\nMIX_ENV=prod mix compile --force\nMIX_ENV=prod mix release\n```\n\n# Examples\nExplore these resources for practical examples of using Jellyfish with Elixir applications:\n\n * [Deployex](https://github.com/thiagoesteves/deployex) - Elixir application showcasing Jellyfish's capabilities in deployment with hot-upgrades.\n * [Deployex](https://github.com/thiagoesteves/calori) - Elixir application using Jellyfish and being able to hot upgrade via DeployEx\n * [Myumbrella](https://github.com/thiagoesteves/myumbrella) - Elixir umbrella application configured for using Jellyfish.","ref":"readme.html#generating-appup-files"},{"type":"extras","title":"Getting involved - Jellyfish","doc":"🗨️ **Contact us:**\nFeel free to contact me on [Linkedin](https://www.linkedin.com/in/thiago-cesar-calori-esteves-972368115/).","ref":"readme.html#getting-involved"},{"type":"extras","title":"Copyright and License - Jellyfish","doc":"Copyright (c) 2024, Thiago Esteves.\n\nDeployEx source code is licensed under the [MIT License](LICENSE.md).\n\n# References\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"The MIT License (MIT)\n\nCopyright (c) 2024 Thiago Esteves\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"CHANGELOG (v0.2.x)","doc":"# CHANGELOG (v0.2.x)","ref":"changelog.html"},{"type":"extras","title":"0.2.0 (2025-04-05) - CHANGELOG (v0.2.x)","doc":"","ref":"changelog.html#0-2-0-2025-04-05"},{"type":"extras","title":"Backwards incompatible changes for 0.1.4 - CHANGELOG (v0.2.x)","doc":"* From version 0.2.x Jellyfish creates a metadata that will be consumed for hotupgrade, allowing elixir umbrella apps to support hot-upgrade.","ref":"changelog.html#backwards-incompatible-changes-for-0-1-4"},{"type":"extras","title":"Installer Actions - CHANGELOG (v0.2.x)","doc":"* None","ref":"changelog.html#installer-actions"},{"type":"extras","title":"Bug fixes - CHANGELOG (v0.2.x)","doc":"* None","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - CHANGELOG (v0.2.x)","doc":"* Added support for Elixir umbrella applications\n\n# Previous Releases\n * [0.1.4 🚀 (2024-10-10)](https://github.com/thiagoesteves/jellyfish/blob/0.1.4/CHANGELOG.md)","ref":"changelog.html#enhancements"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}